<id>
Censor FileAttachments
</id>

<version>
0.1beta
</version>

<mod info>
!!THIS MOD REQUIRES THE FILE ATTACHMENT MOD V2.3 BY DaveB TO BE INSTALLED BEFOREHAND!!
This mod is an addition to the File Attachment Mod. Attached files will be stored in an inaccessible folder and downloading them is disabled, until the board moderator, a global mod or an admin verifies the file to be ok and enables the download.

The temporary directory used to store the files before they are checked should not be readable from the web in order to not open a backdoor access to the files. This can either be achieved by specifying a directory above the website directory, or by putting a ".htaccess" file that contains the following lines: "order deny,allow" and (in the 2. line): "deny from all" in the directory.
</mod info>

<author>
tHE fISH
</author>

<homepage>
vdfilters.videoxone.de
</homepage>

<edit file>
english.lng
</edit file>

<search for>
1;
</search for>

<add before>
$factxt{'1'} = "Attachment not yet released by moderator";
$factxt{'2'} = "Release this attachment";
$factxt{'3'} = "Do you really want to make this file available for download ?";
$factxt{'4'} = "Directory to hold unreleased attachments";

</add before>

<edit file>
YaBB.pl
</edit file>

<search for>
#END FASTFIND C*
}
</search for>

<add before>
	elsif ($action eq 'censorattachment') { require "$sourcedir/Attachments.pl"; &censorattachment; }
</add before>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'10'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="upload_dir" size="35" value="$upload_dir"></td>
  </tr><tr>

</search for>

<add after>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$factxt{'4'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="upload_temp" size="35" value="$upload_temp"></td>
  </tr><tr>
</add after>

<search for>
	$upload_dir = $FORM{'upload_dir'};
</search for>

<add after>
	$upload_temp = $FORM{'upload_temp'};
</add after>

<search for>
\$upload_dir = '$upload_dir';  				# The absolute path to the directory where your attachments are to be stored (without trailing '/' )
</search for>

<add after>
\$upload_temp = '$upload_temp';				# The absolute path to the directory where your attachments are to be stored while they are not yet reviewed by a moderator (without trailing '/' )
</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		# Should we show an attachment file?
			if( $msf && $mfn && $msf ne "" && $mfn ne "") {
			if (-e ("$upload_dir/$mfn")) {
			$attachment = qq~<font size="1"><a href="$msf" target="_blank"><img src="$imagesdir/paperclip.gif" border="0" align="absmiddle">  $mfn</a></font>~;
				if(($mfn =~ /(jpg|gif|bmp|png|jpeg)$/i) && ($amdisplaypics == 1)) {
					$showattach = qq~<hr width="100%"><center><img src="$msf" alt"$msf" border="0"></center>~;
				} else { 
					$showattach = ''; 
				}
</search for>

<add after>
			} elsif (-e ("$upload_temp/$mfn")) {
				fopen (FILE, "$memberdir/$username.dat");
				@usersdata = <FILE>;
				fclose (FILE);
				chop $usersdata[7];
				$userstatus = $usersdata[7];
				if ( ($userstatus eq "Administrator") || ($userstatus eq "Global Moderator") || (exists $moderators{$username}) ) {
					$tmpb2=$INFO{'tmpb'};
					$attachment = qq~<font size="1"><img src="$imagesdir/paperclip.gif" border="0" align="absmiddle">  $mfn <a href="javascript:DoConfirm('$factxt{'3'}','$cgi;action=censorattachment;file=$mfn;mnum=$mnum;start=$tmpb2')">$factxt{'2'}</a></font>~;
					$showattach = '';
				} else {
					$attachment = qq~<font size="1"><img src="$imagesdir/paperclip.gif" border="0" align="absmiddle">  $mfn &nbsp;&nbsp; $factxt{'1'}</font>~;
					$showattach = '';
				}
</add after>

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
			} else {
				if (-e("$upload_dir/$amfn")) {
					unlink("$upload_dir/$amfn");
				}
</search for>

<add after>
				if (-e("$upload_temp/$amfn")) {
					unlink("$upload_temp/$amfn");
				}
</add after>

<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
				} else {
					if (-e("$upload_dir/$amfn")) {
						unlink("$upload_dir/$amfn");
					}
</search for>

<add after>
					if (-e("$upload_temp/$amfn")) {
						unlink("$upload_temp/$amfn");
					}
</add after>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
				if(-e("$upload_dir/$mfn")) { 
</search for>

<replace>
				if ( (-e("$upload_dir/$mfn")) || (-e("$upload_temp/$mfn")) ) { 
</replace>

<search for>
			unlink("$upload_dir/$mfn"); 
</search for>

<add after>
			unlink("$upload_temp/$mfn"); 
</add after>

<search for>
				fclose(AMV);
			unlink("$upload_dir/$mfn"); 
			}
			$messages[$postid] = '';
</search for>

<replace>
				fclose(AMV);
			unlink("$upload_dir/$mfn"); 
			unlink("$upload_temp/$mfn"); 
			}
			$messages[$postid] = '';
</replace>

<search for>
				if(-e("$upload_dir/$mfn")) { 
</search for>

<replace>
				if ( (-e("$upload_dir/$mfn")) || (-e("$upload_temp/$mfn")) ) {
</replace>

<edit file>
Sources/Post.pl
</edit file>

<search for>
opendir(AMD, $upload_dir) || &write_error("$fatxt{'19'} $upload_dir.");
@dirlist = readdir(AMD);
closedir(AMD);
</search for>

<add after>

opendir(AMD2, $upload_temp) || &write_error("$fatxt{'19'} $upload_temp.");
@dirlist2 = readdir(AMD2);
closedir(AMD2);
</add after>

<search for>
foreach $dirlist(@dirlist)
   {
          if ($dirlist eq $file) { &write_error("$fatxt{'8'}"); }

   }
</search for>

<add after>

foreach $dirlist(@dirlist2)
   {
          if ($dirlist eq $file) { &write_error("$fatxt{'8'}"); }

   }
</add after>

<search for>
$write_file = "$upload_dir/$file";
$save_file = "$http_dir/$file"; 
</search for>

<replace>
fopen (FILE, "$memberdir/$username.dat");
@usersdata = <FILE>;
fclose (FILE);
chop $usersdata[7];
$userstatus = $usersdata[7];

if ( ($userstatus EQ "Administrator") || ($userstatus EQ "Global Moderator") || (exists $moderators{$username}) ) {
  $write_file = "$upload_dir/$file";
} else {
  $write_file = "$upload_temp/$file";
}
$save_file = "$http_dir/$file"; 
</replace>

<edit file>
Sources/RemoveOldThreads.pl
</edit file>

<search for>
							if (-e("$upload_dir/$amfn")) {
								unlink("$upload_dir/$amfn");
							}
</search for>

<add after>
							if (-e("$upload_temp/$amfn")) {
								unlink("$upload_temp/$amfn");
							}
</add after>

<edit file>
Sources/RemoveThread.pl
</edit file>

<search for>
			if (-e("$upload_dir/$amfn")) {
				unlink("$upload_dir/$amfn");
			}
</search for>

<add after>
			if (-e("$upload_temp/$amfn")) {
				unlink("$upload_temp/$amfn");
			}
</add after>

<edit file>
Sources/Attachments.pl
</edit file>

<search for>
				$yymain .= qq~ $fn = $result $txt{'122'} ($txt{'123'})<br> ~;
				if(-e("$upload_dir/$fn")) {
					unlink("$upload_dir/$fn");
				}
</search for>

<add after>
				if(-e("$upload_temp/$fn")) {
					unlink("$upload_temp/$fn");
				}
</add after>

<search for>
				$yymain .= qq~ $fn = $size KB ($txt{'123'})<br> ~;
				if(-e("$upload_dir/$fn")) {
					unlink("$upload_dir/$fn");
				}	
</search for>

<add after>
				if(-e("$upload_temp/$fn")) {
					unlink("$upload_temp/$fn");
				}	
</add after>

<search for>
	if (1 > @attachments) {
		$viewattachments .= qq~<tr><td bgcolor=$color{'windowbg2'} colspan="6"><font size="2"><center><b><i>$fatxt{'48'}</i></b></center></font></td></tr>~;
	} else {
		foreach $row (@attachments) {
		chomp $row;
		my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$row);
		if (length($amthreadsub) > 20) { $amthreadsub = substr($amthreadsub,0,20)."..."; }
		$viewattachments .= qq~<tr><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"><a href="$http_dir/$amfn" target="blank"> $amfn</a></td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"> $amkb KB</td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"> $amposter</td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"> $amdate</td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><a href="$scripturl?board=$amcurrentboard;action=display;num=$amthreadid;start=$amreplies" target="blank"><font size="2"> $amthreadsub</a></td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><a href="$scripturl?board=$board;action=deleteattachment;attachment=$amfn"><font size="2"> Delete</a></td></tr>\n~;
		}
	}
</search for>

<replace>
	if (1 > @attachments) {
		$viewattachments .= qq~<tr><td bgcolor=$color{'windowbg2'} colspan="6"><font size="2"><center><b><i>$fatxt{'48'}</i></b></center></font></td></tr>~;
	} else {
		foreach $row (@attachments) {
		chomp $row;
		my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$row);
		if (length($amthreadsub) > 20) { $amthreadsub = substr($amthreadsub,0,20)."..."; }
			if (-e "$upload_dir/$amfn") {
				$viewattachments .= qq~<tr><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"><a href="$http_dir/$amfn" target="blank"> $amfn</a></td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"> $amkb KB</td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"> $amposter</td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"> $amdate</td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><a href="$scripturl?board=$amcurrentboard;action=display;num=$amthreadid;start=$amreplies" target="blank"><font size="2"> $amthreadsub</a></td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><a href="$scripturl?board=$board;action=deleteattachment;attachment=$amfn"><font size="2"> Delete</a></td></tr>\n~;
			} else {
				$viewattachments .= qq~<tr><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"><a href="javascript:confirm_censor('$factxt{'3'}', '$amfn')"> (*) $amfn</a></td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"> $amkb KB</td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"> $amposter</td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><font size="2"> $amdate</td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><a href="$scripturl?board=$amcurrentboard;action=display;num=$amthreadid;start=$amreplies" target="blank"><font size="2"> $amthreadsub</a></td><td bgcolor=$color{'windowbg2'} align="left" valign="middle"><a href="$scripturl?board=$board;action=deleteattachment;attachment=$amfn"><font size="2"> Delete</a></td></tr>\n~;
			}
		}
	}
</replace>

<search for>
function confirm_deleteall (resource)   {
	if (window.confirm(resource) )  {
		window.location.href =  "$scripturl?board=$board;action=deleteattachment;attachment=all";
		}
	}
</search for>

<add after>
function confirm_censor (resource, cfile)   {
	if (window.confirm(resource) )  {
		window.location.href =  "$scripturl?board=$board;action=censorattachment;file=".concat(cfile).concat(";mnum=1000");
		}
	}
</add after>

<search for>
		opendir (AMD,$upload_dir) || &fatal_error("$fatxt{'19'} $upload_dir!");
			while ($files = readdir(AMD)) {
				if ($files ne '.' && $files ne '..') {
					$killfile = "$upload_dir/$files";
					unlink($killfile);
				}
			}
		closedir(AMD);
</search for>

<replace>
		opendir (AMD,$upload_dir) || &fatal_error("$fatxt{'19'} $upload_dir!");
			while ($files = readdir(AMD)) {
				if ($files ne '.' && $files ne '..' && $files ne '.htaccess') {
					$killfile = "$upload_dir/$files";
					unlink($killfile);
				}
			}
		closedir(AMD);
		opendir (AMD,$upload_temp) || &fatal_error("$fatxt{'19'} $upload_temp!");
			while ($files = readdir(AMD)) {
				if ($files ne '.' && $files ne '..' && $files ne '.htaccess') {
					$killfile = "$upload_temp/$files";
					unlink($killfile);
				}
			}
		closedir(AMD);
</replace>

<search for>
				if (-e("$upload_dir/$attachment")) {
					unlink("$upload_dir/$attachment");
				}
</search for>

<add after>
				if (-e("$upload_temp/$attachment")) {
					unlink("$upload_temp/$attachment");
				}
</add after>

<search for>
		fclose(AML);
		$yySetLocation = qq~$cgi;action=manageattachments2~;
		&redirectexit;
	}
}
</search for>

<add after>

sub censorattachment {
  my ($mnum, $start, $file, $newname, $oldname);
  $mnum=$INFO{'mnum'};
  $start=$INFO{'start'};
  $file=$INFO{'file'};

  fopen (FILE, "$memberdir/$username.dat");
  @usersdata = <FILE>;
  fclose (FILE);
  chop $usersdata[7];
  $userstatus = $usersdata[7];
  if ( ($userstatus eq "Administrator") || ($userstatus eq "Global Moderator") || (exists $moderators{$username}) ) {
    $newname="$upload_dir/$file";
    $oldname="$upload_temp/$file";
    if ( (-e $oldname) && (!(-e $newname)) ) {
      rename($oldname, $newname);
    }
  }

if ($mnum EQ 1000) {
	$yymain .= qq~
	<script language="JavaScript1.2" type="text/javascript">
	<!--
  	  location.href=('$cgi;action=manageattachments2')
	//-->
	</script>
	~;
} else {
	$yymain .= qq~
	<script language="JavaScript1.2" type="text/javascript">
	<!--
  	  location.href=('$cgi;action=display;num=$mnum;start=$tmpb')
	//-->
	</script>
	~;
}

}

</add after>
